<?php

# --------------------------------------------------------------------------------------
/*
Simple:Press Template Color Attribute File - Footer
Theme		:	Modern 20202
Color		:	Custom
Author		:	Simple:Press
*/
# --------------------------------------------------------------------------------------

#
# ------------------------------------------------------------------------------------------------------------------------------------
# BASE
# ====================================================================================================================================

	# COLOUR PALETTE
	# The basic colour palette used throughout the theme
	# --------------------------------------------------------------------------------------------------------------------------------
		$stockColor1						=		$ops['C1'];					# Black
		$stockColor2						=		$ops['C2'];					# White
		$stockColor3						=		$ops['C3'];					# Primary Color - Titles, Links and such
		$stockColor4						=		$ops['C4'];					# Secondary Color - text
		$stockColor5						=		$ops['C5'];					# Tertiary Color - Hovers, Button backgrounds, button borders
		$stockColor6						=		$ops['C6'];					# Primary Background 
		$stockColor7						=		$ops['C7'];					# Secondary Background
		$stockColor8						=		$ops['C8'];					# Accent Color - anything else not covered above.
		$stockColor9						=		$ops['C9'];					# Standard Gray
		$stockColor10						=		$ops['C10'];				# Secondary accent color - for mini buttons
		$stockColor11						=		$ops['C11'];				# Primary mobile background color
		$stockColor12						= 		$ops['C12'];				# Not used
		
		$newFlagBackground					= 		$ops['FLAGNEWBG'];			# Background color of new flag
		
		$InputElements01					= 		$ops['IP01'];				# Border for input elements

	# Accent Color
	# Anywhere we need a color that isn't otherwise defined.
	# --------------------------------------------------------------------------------------------------------------------------------
		$primaryAccentColor					=	$stockColor8;					
		$secondaryAccentColor				=	$stockColor10;					
		
	# Some other variables to make it easy to use the colors
	# The variable names 'stockcolorxxx' above is too hard to remember so these make it easier.
	# --------------------------------------------------------------------------------------------------------------------------------
		$primaryColor						=	$stockColor3;
		$secondaryColor						=	$stockColor4;
		$tertiaryColor						=	$stockColor5;
		$primaryBackgroundColor				=	$stockColor6;
		$secondaryBackgroundColor			=	$stockColor7;
		$primaryMobileBackgroundColor		=	$stockColor11;
		$whiteColor							= 	$stockColor2;
		$blackColor							=	$stockColor1;
		$grayColor							=	$stockColor9;

	# BASE FONT RULES
	# Base font styles used throughout the theme
	# --------------------------------------------------------------------------------------------------------------------------------
		$baseFontFamily						=		$ops['FN'];					# Font family (as default inherits from WP theme page wrapper)
		$baseFontWeight						=		'normal';					# Font weight
		$baseFontSize						=		$ops['F1'].'%';				# Font size relative to WP theme page wrapper
		
		$baseFontFamilyMobile				=		$ops['MFN'];				# Font family (as default inherits from WP theme page wrapper)
		$baseFontWeightMobile				=		'normal';					# Font weight
		$baseFontSizeMobile					=		$ops['F2'].'%';				# Font size relative to WP theme page wrapper		

	# GLYPH / ICON COLOURS
	# Glyph / Icon colour palette
	# --------------------------------------------------------------------------------------------------------------------------------
		$iconColor							=		$primaryColor;				# Glyph colour
		$iconColorHover						=		$tertiaryColor;				# Glyph hover colour

	# BASE LINK TEXT
	# Rules for controlling text links throughout theme
	# --------------------------------------------------------------------------------------------------------------------------------
		$linkFontColor						=		$primaryColor;				#
		$linkFontColorHover					=		$primaryColor;				#
		$secLinkFontColor					=		$primaryAccentColor;		#
		$secLinkFontColorHover				=		$primaryAccentColor;		#
		$linkFontSize						=		'100%';						#
		$linkFontWeight						=		'normal';					#

	# BASE/RESET STYLES
	# Base generic styles used throughout the theme
	# --------------------------------------------------------------------------------------------------------------------------------
		$resetTextColor						=	'inherit';
		$resetBackGroundColor				=	'inherit';
		$resetBorderColor					=	'transparent';
		$resetLinkColor						=	$primaryColor;
		$resetLinkHover						=	$primaryColor;
		$resetFontFamily					=	$baseFontFamily;
		$resetFontSize						=	$baseFontSize;
		$resetFontWeight					=	$baseFontWeight;
		$resetFontSizeSmall					=	'90%';
		$resetLineHeight					=	'1.1em';
		$resetBorder						=	'none';
		$resetLinkDecoration				=	'none';

# ------------------------------------------------------------------------------------------------------------------------------------
# UNIVERSAL TEXT
# ====================================================================================================================================

	# TITLE / HEADING TEXT
	# Rules for controlling text in headings and titles throughout theme
	# --------------------------------------------------------------------------------------------------------------------------------
		$titleFontFamily					=		'inherit';					#
		$titleFontColor						=		$primaryColor;				#
		$titleFontSize						=		'130%';						#
		$titleFontWeight					=		'bold';						#
		$titleFontTransform					=		'none';						#
		$titleFontVariant					=		'none';						#

	# SUB TITLE / SUB HEADING TEXT
	# Rules for controlling sub text in headings and titles throughout theme
	# --------------------------------------------------------------------------------------------------------------------------------
		$subTitleFontFamily					=		'inherit';					#
		$subTitleFontColor					=		$tertiaryColor;				#
		$subTitleFontSize					=		'110%';						#
		$subTitleFontWeight					=		'bold';						#
		$subTitleFontTransform				=		'none';						#
		$subTitleFontVariant				=		'none';						#

	# CONTENT TEXT
	# Rules for controlling general content text throughout theme
	# --------------------------------------------------------------------------------------------------------------------------------
		$contentFontFamily					=		'inherit';					#
		$contentFontColor					=		$secondaryColor;			#
		$contentFontSize					=		'100%';						#
		$contentFontWeight					=		'normal';					#
		$contentSmallerFontSize				=		'80%';						#
		$contentSmallestFontSize			=		'60%';						#
		$contentLargerFontSize				=		'130%';						#
		$contentExtraLargeFontSize			=		'160%';						#
		$contentLargestFontSize				=		'200%';						#

	# FORM TEXT
	# Rules for controlling form text
	# --------------------------------------------------------------------------------------------------------------------------------
		$formFontColor						=		$secondaryColor;			#
		$formFontSize						=		'100%';						#
		$formFontWeight						=		'normal';					#

	# INFO TEXT
	# Rules for controlling info text
	# --------------------------------------------------------------------------------------------------------------------------------
		$infoFontColor						=		$primaryAccentColor;		#
		$infoFontSize						=		'60%';						#
		$infoFontWeight						=		'normal';					#

# ------------------------------------------------------------------------------------------------------------------------------------
# BUTTONS / INPUTS / SELECTS ETC..
# ====================================================================================================================================
		$spButtonFontColor					=		$whiteColor;					#
		$spButtonFontColorHover				=		$whiteColor;					#
		$spButtonFontSize					=		'80%';							#
		$spButtonFontWeight					=		'bold';							#
		$spButtonBorder						=		'none';							#		
		$spButtonBorderColor				=		$tertiaryColor;					#
		$spButtonBorderHover				=		'none';							#
		$spButtonBorderHoverColor			=		$primaryAccentColor;			#		
		$spButtonBackground					=		$tertiaryColor;					#
		$spButtonBackgroundHover			=		$primaryAccentColor;			#

		$inputFieldBackground				=		$whiteColor;					#
		$inputFieldBackgroundHover			=		$whiteColor;					#
		$inputFieldBorder					=		"1px solid $InputElements01";	#

# ------------------------------------------------------------------------------------------------------------------------------------
# UNIVERAL BORDERS
# ====================================================================================================================================
		$dottedBorder						=		"1px dotted $grayColor";				#
		$solidBorder						=		"1px solid $grayColor";					#
		$solidBorderLight					=		"1px solid $grayColor";					#
		$solidBorderLightThick				=		"2px solid $grayColor";					#
		$thickBorder						=		"5px solid $grayColor";					#
		$whiteBorder						=		"1px solid $whiteColor";				#
# ------------------------------------------------------------------------------------------------------------------------------------
# SECTION CONTAINERS
# ====================================================================================================================================

	# HEADER / FOOTER CONTAINERS
	# Rules for controlling header & footer containers throughout theme
	# --------------------------------------------------------------------------------------------------------------------------------
		$headerContainerBackground			=		'none';						#
		$headerContainerBorder				=		'none';						#
		$footerContainerBackground			=		$whiteColor;				#
		$footerContainerBorder				=		'none';						#

	# TITLE CONTAINERS
	# Rules for controlling title containers throughout theme
	# --------------------------------------------------------------------------------------------------------------------------------
		$titleContainerBackground			=		$secondaryBackgroundColor;	#
		$titleContainerBorder				=		'none';						#
		$titleColumnsBackground				=		$secondaryBackgroundColor;	#

	# VIEW SECTION CONTAINERS
	# Rules for controlling display sections
	# --------------------------------------------------------------------------------------------------------------------------------
		$groupSectionBackground				=		$secondaryBackgroundColor;			#
		$groupSectionBorder					=		"1px solid $primaryAccentColor";	#
		$forumSectionBackground				=		'transparent';						#
		$forumSectionBorder					=		'none';								#
		$topicSectionBackground				=		'transparent';						#
		$topicSectionBorder					=		'none';								#

	# FORM CONTAINERS
	# Rules for controlling form containers throughout theme
	# --------------------------------------------------------------------------------------------------------------------------------
		$formContainerBackground			=		'none';						#
		$formContainerBorder				=		"1px solid $stockColor4";	#
		$whiteContainer						=		$whiteColor;				#
		$greyContainer						=		$primaryBackgroundColor;	#

	# PLAIN SECTION
	# Rules for controlling plain section containers throughout theme
	# --------------------------------------------------------------------------------------------------------------------------------
		$plainSectionColor					=		'inherit';					#
		$plainSectionBackGround				=		'transparent';				#
		$plainSectionBorder					=		'none';						#
# ------------------------------------------------------------------------------------------------------------------------------------
# FORUM / TOPIC / LIST ROW CONTAINERS
# ====================================================================================================================================

	# FORUM / TOPIC ROW CONTAINERS
	# Rules for controlling forum and topic containers in 'Group View' & 'Forum View'
	# --------------------------------------------------------------------------------------------------------------------------------
		$indexRowOddBackGround				=		'none'; 				#
		$indexRowOddBackGroundHover			=		'none';					#
		$indexRowOddBorder					=		'none';					#
		$indexRowOddBorderHover				=		'none';					#

		$indexRowEvenBackGround				=		'none'; 				#
		$indexRowEvenBackGroundHover		=		'none'; 				#
		$indexRowEvenBorder					=		'none';					#
		$indexRowEvenBorderHover			=		'none';					#

	# FORUM / TOPIC ROW TEXT
	# Rules for controlling forum and topic containers in 'Group View' & 'Forum View'
	# --------------------------------------------------------------------------------------------------------------------------------
		$indexRowOddColor					=		'inherit';					#
		$indexRowOddColorHover				=		'inherit';					#
		$indexRowEvenColor					=		'inherit';					#
		$indexRowEvenColorHover				=		'inherit';					#

	# LIST ROW CONTAINERS
	# Rules for controlling topic list containers in new posts views
	# --------------------------------------------------------------------------------------------------------------------------------
		$listRowBackGround					=		$whiteColor; 				#
		$listRowBackGroundHover				=		$whiteColor; 				#

# ------------------------------------------------------------------------------------------------------------------------------------
# TOPIC VIEW
# ====================================================================================================================================

	# CONTAINERS
	# Rules for controlling post container styles in 'Topic View'
	# --------------------------------------------------------------------------------------------------------------------------------
		$topicViewSectionColor				=	$blackColor; 							#
		$topicViewSectionBackGroundColor	=	$whiteColor;							#
		$topicViewSectionBorder				=	'none'	;								#
		$topicViewSectionBorderTop			=	"1px solid $primaryBackgroundColor"	;	# Can set top border even if the border variable 1 line above this is set to 'none'
		$topicViewSectionBorderBottom		=	'none'	;								# Can set bottom border even if the border variable 2 lines above this is set to 'none'

	# USER PANE
	# Rules for controlling post container styles in 'Topic View'
	# --------------------------------------------------------------------------------------------------------------------------------
		$topicUserSectionBackGround			=	'none'; 						#

	# POST PANE
	# Rules for controlling post container styles in 'Topic View'
	# --------------------------------------------------------------------------------------------------------------------------------
		$postSectionBackGroundColor			=	$whiteColor; 					#
		$postCiteBackGroundColor			=	$primaryBackgroundColor;		#
		$postCodeBackGroundColor			=	$primaryBackgroundColor;		#

		$postHeadingh1						=	'1.6em';						#
		$postHeadingh2						=	'1.5em';						#
		$postHeadingh3						=	'1.4em';						#
		$postHeadingh4						=	'1.3em';						#
		$postHeadingh5						=	'1.2em';						#
		$postHeadingh6						=	'1.1em';						#

		$postLineHeight						= 	'1.3em';
# ------------------------------------------------------------------------------------------------------------------------------------
# BACKGROUND IMAGES
# ====================================================================================================================================
		$ImageClose							='url("images/close.gif")';
		$ImageCloseMobile					='url("images/closeDark.gif")';
		$ImageResize						='url("images/resize.gif")';
		$Imagedd_arrow						='url("images/dd_arrow.gif") no-repeat 0 0';
		$Imagesp_ImageOverlay				='#666666 url("images/sp_ImageOverlay.png") 50% 50% repeat';

# ------------------------------------------------------------------------------------------------------------------------------------
# MISCELLANEOUS
# ====================================================================================================================================

	# UI-DIALOG
	# Rules for controlling popup dialog styles
	# --------------------------------------------------------------------------------------------------------------------------------
		$popupHeaderColor					=	$whiteColor;					#
		$popupBackground					=	$tertiaryColor;					#

	# TOOLTIPS
	# Rules for controlling tooltip styles
	# --------------------------------------------------------------------------------------------------------------------------------
		$toolTipsColor						=	$stockColor2;					#
		$toolTipsFontFamily					=	'inherit';						#
		$toolTipsFontSize					=	$contentSmallerFontSize;		#
		$toolTipsBackground					=	'#5C5C5C';						#
		$toolTipsBorder						=	'none';							#

	# CHECK BOXES
	# Rules for controlling checkbox styles
	# --------------------------------------------------------------------------------------------------------------------------------
		$checkBoxBackground					=	$stockColor2;	# Used for check boxes and radio controls
		$checkBoxDisabledBackground			=	$stockColor6;	# Used for disabled check boxes and radio controls
		$checkBoxTickColor					=	$stockColor5;	# Used for checkbox and radio control ticks
		$checkBoxDisabledColor				=	$stockColor6;	# Used for disabled check boxes and radio controls

	# QuickLinks
	# Possibly remove as no QuickLinks exist
	# --------------------------------------------------------------------------------------------------------------------------------
		$quickLinksTopicsPostNew			=	$contentFontColor;		# Used for New Topics (Posts) in QuickLinks (Topics)
		$quickLinksTopicsPostMod			=	$primaryAccentColor;	# Used for New Topics (Posts awaiting Moderation) in QUickLinks (Topics)
		$quickLinksTopicsPostRead			=	$secondaryAccentColor;	# Used for Read Topics in QuickLinks (Topics)

		$quickLinksSelectWidth				=	'250px';
		$quickLinksListWidth				=	'350px';
		$quickLinksSelectMobileWidth		=	'200px';
		$quickLinksSelectMobileWidthSmall	=	'160px';
		$quickLinksListMobileWidth			=	'260px';
		$quickLinksListMobileWidthSmall		=	'248px';

# ------------------------------------------------------------------------------------------------------------------------------------
# COLUMN WIDTHS FOR VIEWS
# ====================================================================================================================================

# GROUP VIEW ========================

$ColGroup_1 = array();
$ColGroup_2 = array();
$ColGroup_3 = array();
$ColGroup_4 = array();

$ColGroup_1[0]		= '5%';
$ColGroup_1[800]	= '6%';
$ColGroup_1[720]	= '7%';
$ColGroup_1[600]	= '0%';
$ColGroup_1[480]	= '0%';
$ColGroup_1[360]	= '0%';

$ColGroup_2[0]		= '45%';
$ColGroup_2[800]	= '45%';
$ColGroup_2[720]	= '45%';
$ColGroup_2[600]	= '48%';
$ColGroup_2[480]	= '48%';
$ColGroup_2[360]	= '48%';

$ColGroup_3[0]		= '10%';
$ColGroup_3[800]	= '46%';
$ColGroup_3[720]	= '44%';
$ColGroup_3[600]	= '48%';
$ColGroup_3[480]	= '48%';
$ColGroup_3[360]	= '48%';

$ColGroup_4[0]		= '30%';
$ColGroup_4[800]	= '35%';
$ColGroup_4[720]	= '35%';
$ColGroup_4[600]	= '35%';
$ColGroup_4[480]	= '35%';
$ColGroup_4[360]	= '35%';

$ColGroup_5[0]		= '5%';
$ColGroup_5[800]	= '3%';
$ColGroup_5[720]	= '6%';
$ColGroup_5[500]	= '6%';
$ColGroup_5[480]	= '6%';
$ColGroup_5[360]	= '3%';

# FORUM VIEW ========================

$ColForum_1 = array();
$ColForum_2 = array();
$ColForum_3 = array();
$ColForum_4 = array();

$ColForum_1[0]		= '5%';
$ColForum_1[800]	= '5%';
$ColForum_1[720]	= '5%';
$ColForum_1[600]	= '5%';
$ColForum_1[480]	= '5%';
$ColForum_1[360]	= '5%';

$ColForum_2[0]		= '50%';
$ColForum_2[800]	= '50%';
$ColForum_2[720]	= '50%';
$ColForum_2[600]	= '50%';
$ColForum_2[480]	= '50%';
$ColForum_2[360]	= '50%';

$ColForum_3[0]		= '25%';
$ColForum_3[800]	= '25%';
$ColForum_3[720]	= '25%';
$ColForum_3[600]	= '25%';
$ColForum_3[480]	= '25%';
$ColForum_3[360]	= '25%';

$ColForum_4[0]		= '8%';
$ColForum_4[800]	= '8%';
$ColForum_4[720]	= '8%';
$ColForum_4[500]	= '8%';
$ColForum_4[480]	= '8%';
$ColForum_4[360]	= '8%';

$ColForum_5[0]		= '8%';
$ColForum_5[800]	= '8%';
$ColForum_5[720]	= '8%';
$ColForum_5[500]	= '8%';
$ColForum_5[480]	= '8%';
$ColForum_5[360]	= '8%';

# TOPIC VIEW ================

$ColTopic_1 = array();
$ColTopic_2 = array();

$ColTopic_1[0]		= '15%';
$ColTopic_1[800]	= '15%';
$ColTopic_1[720]	= '16%';
$ColTopic_1[600]	= '16%';
$ColTopic_1[480]	= '16%';
$ColTopic_1[360]	= '17%';

$ColTopic_2[0]		= '84%';
$ColTopic_2[800]	= '84%';
$ColTopic_2[720]	= '82%';
$ColTopic_2[600]	= '82%';
$ColTopic_2[480]	= '82%';
$ColTopic_2[360]	= '81%';
